package {
	import classes.utils.FontHandler;
	import classes.utils.SlideView;
	
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;

	public class DynamicSlideShow extends Sprite
	{
		//----------------------------------------------------------------------
        //
        // Public Static Properties
        //
        //----------------------------------------------------------------------
        
        public static var xmlProperties	:XML;
        
        public static var tweenTime		:Number;
        
        public static var totalSlides	:uint;
        
        public static var imagesArray	:Array;
        
        public static var labelsArray	:Array;
        
        public static var displayLabels	:Boolean;
        
        public static var useNavigation	:Boolean;
        
        //----------------------------------------------------------------------
        //
        // Constructor
        //
        //----------------------------------------------------------------------
        
		public function DynamicSlideShow()
		{
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align		= StageAlign.TOP_LEFT;
			
			//var slidesfile:String = "data/slides.xml";
			
			var slidesfile:String = root.loaderInfo.parameters.xmlFile;
			
			var xmlLoader:URLLoader = new URLLoader();
			xmlLoader.addEventListener( Event.COMPLETE, xmlLoadedHandler, false, 0, true );
			xmlLoader.load( new URLRequest ( slidesfile ) );
		}
		
		//----------------------------------------------------------------------
        //
        // Private Methods
        //
        //----------------------------------------------------------------------
        
        private function xmlLoadedHandler( e:Event ):void
        {
        	xmlProperties			= new XML( e.target.data );
        	
        	var slides:XMLList		= xmlProperties.slide;
        	
        	totalSlides				= slides.length();
        	
        	imagesArray				= new Array();
        	
        	displayLabels			= toBoolean( xmlProperties.labels );
        	
        	useNavigation			= toBoolean( xmlProperties.navigation );
        	
        	var item:XML;
        	
        	if( displayLabels )
        	{
        		labelsArray			= new Array();
        		
        		for each( item in slides )
        		{
        			imagesArray.push( item.image );
        			labelsArray.push( item.label );
        		}
        		
        		var stylesheet:String	= xmlProperties.stylesheet;
        		var fontswf:String		= xmlProperties.fontswf;
        		
        		var fonthandler:FontHandler = new FontHandler();
        		fonthandler.loadCSS( stylesheet, fontswf );
        		fonthandler.addEventListener( Event.COMPLETE, initView, false, 0, true );
        	}
        	else
        	{
        		for each( item in slides )
        		{
        			imagesArray.push( item.image );
        		}
        	
        		initView( new Event( Event.COMPLETE ) );
        	}
        }
        
        private function toBoolean( val:String ):Boolean
        {
        	if( val == "true" )
        	{
        		return true;
        	}
        	else
        	{
        		return false;
        	}
        }
        
        private function initView( e:Event ):void
        {
        	var slideview:SlideView = new SlideView();
        	
        	addChild( slideview );
        }
	}
}
