package classes.elements
{
	import classes.events.NavigationEvent;
	
	import flash.display.Bitmap;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	
	import gs.TweenLite;

	public class NavButton extends Sprite
	{
		//----------------------------------------------------------------------
        //
        // Private Properties
        //
        //----------------------------------------------------------------------
        
        private var _loader:Loader;
        
        private var _iconpath:String;
        
        
        //----------------------------------------------------------------------
        //
        // Constructor
        //
        //----------------------------------------------------------------------
        
		public function NavButton( iconpath:String )
		{
			_iconpath = iconpath;
			
			addEventListener( Event.ADDED_TO_STAGE, onStageHandler, false, 0, true );
		}
		
		//----------------------------------------------------------------------
        //
        // Private Methods
        //
        //----------------------------------------------------------------------
        
		private function onStageHandler( e:Event ):void
		{
			_loader = new Loader();
			_loader.contentLoaderInfo.addEventListener( Event.COMPLETE, iconLoadedHandler, false, 0, true );
			_loader.load( new URLRequest( _iconpath ) );
			
			this.buttonMode = true;
			this.useHandCursor = true;
			
			addEventListener( MouseEvent.ROLL_OVER, navOverHandler, false, 0, true );
			addEventListener( MouseEvent.ROLL_OUT, navOutHandler, false, 0, true );
			addEventListener( MouseEvent.CLICK, navClickHandler, false, 0, true );
		}
		
		private function iconLoadedHandler( e:Event ):void
		{
			_loader.contentLoaderInfo.removeEventListener( Event.COMPLETE, iconLoadedHandler );
			
			var icon:Bitmap			= e.target.content as Bitmap;
			icon.x					= - ( icon.width * 0.5 );
			icon.y					= - ( icon.height * 0.5 );
			
			addChild( icon );
			
			this.alpha = 0.6;
		}
		
		private function navOverHandler( e:MouseEvent ):void
		{
			new TweenLite( this, 0.4, { alpha:1 } );
		}
		
		private function navOutHandler( e:MouseEvent ):void
		{
			new TweenLite( this, 0.4, { alpha:0.6 } );
		}
		
		private function navClickHandler( e:MouseEvent ):void
		{
			if( this.name == "navNext" )
			{
				dispatchEvent( new NavigationEvent( NavigationEvent.NEXT_SLIDE, "next" ) );
			}
			else
			{
				dispatchEvent( new NavigationEvent( NavigationEvent.PREV_SLIDE, "prev" ) );
			}
		}
	}
}