package classes.utils
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.HTTPStatusEvent;
	import flash.events.IOErrorEvent;
	import flash.events.SecurityErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.text.*;
	
	import ru.etcs.utils.FontLoader;
	
	public class FontHandler extends Sprite
	{
		//----------------------------------------------------------------------
        //
        // Public Static Properties
        //
        //----------------------------------------------------------------------
        
        public static var _cssStyleSheet:StyleSheet;
        
        //----------------------------------------------------------------------
        //
        // Private Properties
        //
        //----------------------------------------------------------------------
		
		private var _urlLoader:URLLoader;
		
		private var _fontLoader:FontLoader;
		
		private var _fontswf:String;
		
		//----------------------------------------------------------------------
        //
        // Constructor
        //
        //----------------------------------------------------------------------
        
		public function FontHandler()
		{
			super();
		}
		
		//----------------------------------------------------------------------
        //
        // Public Methods
        //
        //----------------------------------------------------------------------
        
		public function loadCSS(cssfile:String, fontswf:String):void
		{
			_fontswf = fontswf;
			
			_urlLoader = new URLLoader();
			
			_urlLoader.addEventListener( Event.COMPLETE, cssLoadedHandler, false, 0, true );
		
			_urlLoader.load ( new URLRequest( cssfile ) );
		}
		
		//----------------------------------------------------------------------
        //
        // Private Methods
        //
        //----------------------------------------------------------------------
        
		private function cssLoadedHandler (e:Event):void
		{
			_urlLoader.removeEventListener( Event.COMPLETE, cssLoadedHandler );
			
			_cssStyleSheet = new StyleSheet();
		
			_cssStyleSheet.parseCSS ( _urlLoader.data );
			
			loadFonts ( new URLRequest( _fontswf ) );
		}
		
		private function loadFonts ( request:URLRequest ):void
		{
			_fontLoader = new FontLoader();
		
			_fontLoader.addEventListener ( Event.COMPLETE, fontsLoadedHandler, false, 0, true );
		
			_fontLoader.load ( request );
		}
		
		private function fontsLoadedHandler (e:Event):void
		{
			var fontArray:Array = _fontLoader.fonts;
			
			var font:Font;
			
			for each ( font in fontArray )
			{
				trace(" FONT	: " + font.fontName);
				trace(" STYLE	: " + font.fontStyle);
				trace(" \n");
			}
			
			dispatchEvent( new Event( Event.COMPLETE ) );
		}
	}
}