package classes.utils
{
	import flash.display.Sprite;
	import flash.events.Event;
	
	import gs.TweenMax;
	import gs.easing.*;

	public class TweenManager extends Sprite
	{
		//----------------------------------------------------------------------
        //
        // Public Properties
        //
        //----------------------------------------------------------------------
        
        public var currSlide	:Sprite;
        
        public var prevSlide	:Sprite;
        
        public var tweenType	:String;
        
        public var tweenEase	:Function
        
         //----------------------------------------------------------------------
        //
        // Private Properties
        //
        //----------------------------------------------------------------------
        
        private var _stagewidth	:Number;
        
        private var _stageheight:Number;
        
        private var _firstTween :Boolean	= true;
        
        //----------------------------------------------------------------------
        //
        // Constructor
        //
        //----------------------------------------------------------------------
        
		public function TweenManager()
		{
			addEventListener( Event.ADDED_TO_STAGE, onStageHandler, false, 0, true );
		}
		
		//----------------------------------------------------------------------
        //
        // Private Methods
        //
        //----------------------------------------------------------------------
        
        private function onStageHandler( e:Event ):void
        {
        	removeEventListener( Event.ADDED_TO_STAGE, onStageHandler );
        	
        	_stagewidth		= stage.stageWidth;
        	
        	_stageheight		= stage.stageHeight;
        }
        
        //----------------------------------------------------------------------
        //
        // Public Methods
        //
        //----------------------------------------------------------------------
        
        public function RestoreTweens( direction:String = "next_slide" ):void
        {	
        	if( _firstTween )
        	{
        		currSlide.alpha = 0;
        	}
        	else
        	{
        		if( direction == "next_slide" )
	        	{
	        		switch ( tweenType )
					{
						case "fade" :
						currSlide.alpha = 0;
						break;
						
						case "blur" :
						new TweenMax( currSlide, 0, { alpha:0, blurFilter:{ blurX:10, blurY:10 } } );
						break;
						
						case "rightWipe" :
						currSlide.x = _stagewidth;
						break;
						
						case "leftWipe" :
						currSlide.x = - _stagewidth;
						break;
						
						case "topWipe" :
						currSlide.y = - _stageheight;
						break;
						
						case "bottomWipe" :
						currSlide.y = _stageheight;
						break;
						
						default :
						currSlide.alpha = 0;
					}
	        	}
	        	else
	        	{
	        		switch ( tweenType )
					{
						case "fade" :
						currSlide.alpha = 0;
						break;
						
						case "blur" :
						new TweenMax( currSlide, 0, { alpha:0, blurFilter:{ blurX:DynamicSlideShow.xmlProperties.blurAmount, blurY:DynamicSlideShow.xmlProperties.blurAmount } } );
						break;
						
						case "rightWipe" :
						currSlide.x = - _stagewidth;
						break;
						
						case "leftWipe" :
						currSlide.x = _stagewidth;
						break;
						
						case "topWipe" :
						currSlide.y = _stageheight;
						break;
						
						case "bottomWipe" :
						currSlide.y = - _stageheight;
						break;
						
						default :
						currSlide.alpha = 0;
					}
	        	}
        	}
        }
        
        public function TweenObjects( direction:String = "next_slide" ):void
        {
        	if( _firstTween )
        	{
        		new TweenMax( currSlide, DynamicSlideShow.xmlProperties.tweenTime, { alpha:1, ease:tweenEase, onComplete:completeFunction } );
        		_firstTween = false;
        	}
        	else
        	{
        		if( direction == "next_slide" )
	        	{
	        		switch ( tweenType )
					{
						case "fade" :
						new TweenMax( currSlide, DynamicSlideShow.xmlProperties.tweenTime, { alpha:1, ease:tweenEase, onComplete:completeFunction } );
						break;
						
						case "blur" :
						new TweenMax( currSlide, DynamicSlideShow.xmlProperties.tweenTime, { alpha:1, ease:tweenEase, blurFilter:{ blurX:0, blurY:0 }, onComplete:completeFunction } );
						break;
						
						case "rightWipe" :
						new TweenMax( currSlide, DynamicSlideShow.xmlProperties.tweenTime, { x:0, ease:tweenEase, onComplete:completeFunction } );
						new TweenMax( prevSlide, DynamicSlideShow.xmlProperties.tweenTime, { x:- _stagewidth, ease:tweenEase } );
						break;
						
						case "leftWipe" :
						new TweenMax( currSlide, DynamicSlideShow.xmlProperties.tweenTime, { x:0, ease:tweenEase, onComplete:completeFunction } );
						new TweenMax( prevSlide, DynamicSlideShow.xmlProperties.tweenTime, { x:_stagewidth, ease:tweenEase } );
						break;
						
						case "topWipe" :
						new TweenMax( currSlide, DynamicSlideShow.xmlProperties.tweenTime, { y:0, ease:tweenEase, onComplete:completeFunction } );
						new TweenMax( prevSlide, DynamicSlideShow.xmlProperties.tweenTime, { y:_stageheight, ease:tweenEase } );
						break;
						
						case "bottomWipe" :
						new TweenMax( currSlide, DynamicSlideShow.xmlProperties.tweenTime, { y:0, ease:tweenEase, onComplete:completeFunction } );
						new TweenMax( prevSlide, DynamicSlideShow.xmlProperties.tweenTime, { y:- _stageheight, ease:tweenEase } );
						break;
						
						default :
						new TweenMax( currSlide, DynamicSlideShow.xmlProperties.tweenTime, { alpha:1, ease:tweenEase, onComplete:completeFunction } );
					}
	        	}
	        	else
	        	{
	        		switch ( tweenType )
					{
						case "fade" :
						new TweenMax( currSlide, DynamicSlideShow.xmlProperties.tweenTime, { alpha:1, ease:tweenEase, onComplete:completeFunction } );
						break;
						
						case "blur" :
						new TweenMax( currSlide, DynamicSlideShow.xmlProperties.tweenTime, { alpha:1, ease:tweenEase, blurFilter:{ blurX:0, blurY:0 }, onComplete:completeFunction } );
						break;
						
						case "rightWipe" :
						new TweenMax( currSlide, DynamicSlideShow.xmlProperties.tweenTime, { x:0, ease:tweenEase, onComplete:completeFunction } );
						new TweenMax( prevSlide, DynamicSlideShow.xmlProperties.tweenTime, { x:_stagewidth, ease:tweenEase } );
						break;
						
						case "leftWipe" :
						new TweenMax( currSlide, DynamicSlideShow.xmlProperties.tweenTime, { x:0, ease:tweenEase, onComplete:completeFunction } );
						new TweenMax( prevSlide, DynamicSlideShow.xmlProperties.tweenTime, { x:- _stagewidth, ease:tweenEase } );
						break;
						
						case "topWipe" :
						new TweenMax( currSlide, DynamicSlideShow.xmlProperties.tweenTime, { y:0, ease:tweenEase, onComplete:completeFunction } );
						new TweenMax( prevSlide, DynamicSlideShow.xmlProperties.tweenTime, { y:- _stageheight, ease:tweenEase } );
						break;
						
						case "bottomWipe" :
						new TweenMax( currSlide, DynamicSlideShow.xmlProperties.tweenTime, { y:0, ease:tweenEase, onComplete:completeFunction } );
						new TweenMax( prevSlide, DynamicSlideShow.xmlProperties.tweenTime, { y:_stageheight, ease:tweenEase } );
						break;
						
						default :
						new TweenMax( currSlide, DynamicSlideShow.xmlProperties.tweenTime, { alpha:1, ease:tweenEase, onComplete:completeFunction } );
					}
	        	}
        	}
        }
        
        private function completeFunction():void
        {
        	dispatchEvent( new Event( Event.COMPLETE ) );
        }
	}
}